﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Security.Cryptography;
using System.Security.Cryptography.X509Certificates;
public partial class Send : System.Web.UI.Page
{
    #region 参数说明

    public string inputCharset = "1";
    //接收支付结果的页面地址
    public string pageUrl = "http://localhost:62777/receivePg.aspx";
    //服务器接收支付结果的后台地址
    public string bgUrl = "http://localhost:62777/receiveBg.aspx";
    //网关版本，固定值：3.0
    public string version = "3.0";
    //语言种类，1代表中文显示，2代表英文显示。默认为1,该参数必填。
    public string language = "1";
    //签名类型,该值为4，代表PKI加密方式,该参数必填。
    public string signType = "4";
    //商户会员号
    public string merchantAcctId = "1001215986001";
    //交易终端号
    public string terminalId = "0010002";
    //编码方式，1代表 UTF-8;  默认为1,该参数必填。

    //支付人姓名,可以为空。
    public string payerName = "";
    //支付人联系类型，1 代表电子邮件方式；2 代表手机联系方式。可以为空。
    public string payerContactType = "";
    //支付人联系方式，与payerContactType设置对应，payerContactType为1，则填写邮箱地址；payerContactType为2，则填写手机号码。可以为空。
    public string payerContact = "";
    //支付人身份证号
    public string payerIdentityCard = "";
    //支付人手机号
    public string mobileNumber = "";
    //支付卡号
    public string cardNumber = "";
    //商户客户号
    public string customerId = "";

    //商户订单号，以下采用时间来定义订单号，商户可以根据自己订单号的定义规则来定义该值，不能为空。
    public string orderId = DateTime.Now.ToString("yyyyMMddHHmmss");
    //询盘流水号，可为空
    public string inquireTrxNo = "";
    //订单币别,不可空
    public string orderCurrency = "USD";
    //结算币别，不可空
    public string settlementCurrency = "USD";
    //订单金额，金额以“分”为单位，商户测试以1分测试即可，切勿以大金额测试。该参数必填。
    public string orderAmount = "120";
    //订单提交时间，格式：yyyyMMddHHmmss，如：20071117020101，不能为空。
    public string orderTime = DateTime.Now.ToString("yyyyMMddHHmmss");
    //商品名称，可以为空。
    public string productName = "Phone";
    //商品数量，可以为空。
    public string productNum = "1";
    //商品代码，可以为空。
    public string productId = "100032";
    //商品描述，可以为空。
    public string productDesc = "Its a phpne";
    //扩展字段1，商户可以传递自己需要的参数，支付完会原值返回，可以为空。
    public string ext1 = "";
    //扩展自段2，商户可以传递自己需要的参数，支付完会原值返回，可以为空。
    public string ext2 = "";
    //支付方式，一般为00-所有，10-直连所有，10-1个人网关，10-2企业网银
    public string payType = "00";
    //银行代码，直连时需要传值
    public string bankId = "";
    public string redoFlag = "";
   
    // signMsg 签名字符串 不可空，生成加密签名串
    public string signMsg = "";
    #endregion
    protected void Page_Load(object sender, EventArgs e)
    {
        //拼接字符串
        string signMsgVal = "";
        signMsgVal = appendParam(signMsgVal, "inputCharset", inputCharset);
        signMsgVal = appendParam(signMsgVal, "pageUrl", pageUrl);
        signMsgVal = appendParam(signMsgVal, "bgUrl", bgUrl);
        signMsgVal = appendParam(signMsgVal, "version", version);
        signMsgVal = appendParam(signMsgVal, "language", language);
        signMsgVal = appendParam(signMsgVal, "signType", signType);
        signMsgVal = appendParam(signMsgVal, "merchantAcctId", merchantAcctId);
	    signMsgVal = appendParam(signMsgVal, "terminalId", terminalId);

        signMsgVal = appendParam(signMsgVal, "payerName", payerName);
        signMsgVal = appendParam(signMsgVal, "payerContactType", payerContactType);
        signMsgVal = appendParam(signMsgVal, "payerContact", payerContact);
	    signMsgVal = appendParam(signMsgVal, "payerIdentityCard", payerIdentityCard);
	    signMsgVal = appendParam(signMsgVal, "mobileNumber", mobileNumber);
	    signMsgVal = appendParam(signMsgVal, "cardNumber", cardNumber);
        signMsgVal = appendParam(signMsgVal, "customerId", customerId);
        signMsgVal = appendParam(signMsgVal, "orderId", orderId);
        signMsgVal = appendParam(signMsgVal, "inquireTrxNo", inquireTrxNo);
        signMsgVal = appendParam(signMsgVal, "orderCurrency", orderCurrency);
        signMsgVal = appendParam(signMsgVal, "settlementCurrency", settlementCurrency);

        signMsgVal = appendParam(signMsgVal, "orderAmount", orderAmount);
        signMsgVal = appendParam(signMsgVal, "orderTime", orderTime);
        signMsgVal = appendParam(signMsgVal, "productName", productName);
        signMsgVal = appendParam(signMsgVal, "productNum", productNum);
        signMsgVal = appendParam(signMsgVal, "productId", productId);

        signMsgVal = appendParam(signMsgVal, "productDesc", productDesc);
        signMsgVal = appendParam(signMsgVal, "ext1", ext1);
        signMsgVal = appendParam(signMsgVal, "ext2", ext2);
        signMsgVal = appendParam(signMsgVal, "payType", payType);
        signMsgVal = appendParam(signMsgVal, "bankId", bankId);
        signMsgVal = appendParam(signMsgVal, "redoFlag", redoFlag);


        ///PKI加密
	///编码方式UTF-8 GB2312  用户可以根据自己系统的编码选择对应的加密方式
        ///byte[] OriginalByte=Encoding.GetEncoding("GB2312").GetBytes(OriginalString);
        byte[] bytes = System.Text.Encoding.UTF8.GetBytes(signMsgVal);
        X509Certificate2 cert = new X509Certificate2(HttpContext.Current.Server.MapPath("10012159860.pfx"), "123456", X509KeyStorageFlags.MachineKeySet);
        RSACryptoServiceProvider rsapri = (RSACryptoServiceProvider)cert.PrivateKey;
        RSAPKCS1SignatureFormatter f = new RSAPKCS1SignatureFormatter(rsapri);
        byte[] result;
        f.SetHashAlgorithm("SHA1");
        SHA1CryptoServiceProvider sha = new SHA1CryptoServiceProvider();
        result = sha.ComputeHash(bytes);
        signMsg = System.Convert.ToBase64String(f.CreateSignature(result)).ToString();
      

    }

    //功能函数。将变量值不为空的参数组成字符串
    #region 字符串串联函数
    public string appendParam(string returnStr, string paramId, string paramValue)
    {
        if (returnStr != "")
        {
            if (paramValue != "")
            {
                returnStr += "&" + paramId + "=" + paramValue;
            }
        }
        else
        {
            if (paramValue != "")
            {
                returnStr = paramId + "=" + paramValue;
            }
        }
        return returnStr;
    }
    #endregion
}
